declare const SNODE: unique symbol, SPROXY: unique symbol;
declare type StateNode = {
    [SNODE]?: any;
    [SPROXY]?: any;
    [k: string]: any;
    [k: number]: any;
};
declare type AddSymbolToPrimitive<T> = T extends {
    [Symbol.toPrimitive]: infer V;
} ? {
    [Symbol.toPrimitive]: V;
} : {};
declare type AddCallable<T> = T extends {
    (...x: any[]): infer V;
} ? {
    (...x: Parameters<T>): V;
} : {};
export declare type Wrapped<T> = {
    [P in keyof T]: T[P] extends object ? Wrapped<T[P]> : T[P];
} & {
    _state?: T;
} & AddSymbolToPrimitive<T> & AddCallable<T>;
declare type StateSetter<T> = Partial<T> | ((prevState: Wrapped<T>, traversed?: (string | number)[]) => Partial<T> | void);
declare type StatePathRange = {
    from?: number;
    to?: number;
    by?: number;
};
declare type StatePathPart = string | number | (string | number)[] | StatePathRange | ((item: any, index: number) => boolean);
declare type StatePath<T> = [keyof T, StateSetter<unknown>] | [keyof T, StatePathPart, StateSetter<unknown>] | [keyof T, StatePathPart, StatePathPart, StateSetter<unknown>] | [keyof T, StatePathPart, StatePathPart, StatePathPart, StateSetter<unknown>] | [keyof T, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StateSetter<unknown>] | [keyof T, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StateSetter<unknown>] | [keyof T, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StatePathPart, StateSetter<unknown>];
export declare function isWrappable(obj: any): boolean;
export declare function unwrap<T extends StateNode>(item: any): T;
export declare function setProperty(state: StateNode, property: string | number, value: any, force?: boolean): void;
interface SetStateFunction<T> {
    (update: StateSetter<T>): void;
    (...path: StatePath<T>): void;
}
export declare function createState<T extends StateNode>(state: T | Wrapped<T>): [Wrapped<T>, SetStateFunction<T>];
export declare function force<T>(value: T | Wrapped<T>): (state: Wrapped<T>) => void;
export {};
